--- old/usr/src/cmd/ptools/Makefile	2015-05-27 22:21:43.822971569 -0400
+++ new/usr/src/cmd/ptools/Makefile	2015-05-27 22:21:43.843112025 -0400
@@ -54,7 +54,8 @@
 	plgrp	\
 	pmadvise \
 	ppriv	\
-	preap
+	preap	\
+	psecflags
 
 SUBDIRS = $(LEGACY_SUBDIRS) $(NEW_SUBDIRS)
 
@@ -73,7 +74,7 @@
 #
 # Commands with messages support
 #
-POFILES = plgrp/plgrp.po pmadvise/pmadvise.po
+POFILES = plgrp/plgrp.po pmadvise/pmadvise.po psecflags/psecflags.po
 POFILE = ptools.po
 
 .KEEP_STATE:
--- old/usr/src/cmd/ptools/Makefile.bld	2015-05-27 22:21:44.402949814 -0400
+++ new/usr/src/cmd/ptools/Makefile.bld	2015-05-27 22:21:44.470348653 -0400
@@ -34,23 +34,24 @@
 
 # libproc is added individually as pwait doesn't need it.
 # These are defined this way so lint can use them
-LDLIBS_pargs	= -lproc
-LDLIBS_pcred	= -lproc
-LDLIBS_pfiles	= -lproc -lnsl
-LDLIBS_pflags	= -lproc
-LDLIBS_pldd	= -lproc
-LDLIBS_plgrp	= -lproc -llgrp
-LDLIBS_pmap	= -lproc
-LDLIBS_pmadvise	= -lproc
-LDLIBS_ppriv	= -lproc
-LDLIBS_preap	= -lproc
-LDLIBS_prun	= -lproc
-LDLIBS_psig	= -lproc
-LDLIBS_pstack	= -lproc -lc_db
-LDLIBS_pstop	= -lproc
-LDLIBS_ptime	= -lproc
-LDLIBS_ptree	= -lproc -lcontract
-LDLIBS_pwdx	= -lproc
+LDLIBS_pargs		= -lproc
+LDLIBS_pcred		= -lproc
+LDLIBS_pfiles		= -lproc -lnsl
+LDLIBS_pflags		= -lproc
+LDLIBS_pldd		= -lproc
+LDLIBS_plgrp		= -lproc -llgrp
+LDLIBS_pmap		= -lproc
+LDLIBS_pmadvise		= -lproc
+LDLIBS_ppriv		= -lproc
+LDLIBS_preap		= -lproc
+LDLIBS_prun		= -lproc
+LDLIBS_psecflags	= -lproc -lproject
+LDLIBS_psig		= -lproc
+LDLIBS_pstack		= -lproc -lc_db
+LDLIBS_pstop		= -lproc
+LDLIBS_ptime		= -lproc
+LDLIBS_ptree		= -lproc -lcontract
+LDLIBS_pwdx		= -lproc
 
 LDLIBS += $(LDLIBS_$(PROG))
 
--- old/usr/src/cmd/ptools/pargs/pargs.c	2015-05-27 22:21:45.601672025 -0400
+++ new/usr/src/cmd/ptools/pargs/pargs.c	2015-05-27 22:21:45.665783492 -0400
@@ -772,6 +772,30 @@
 	}
 }
 
+static struct auxsecfl {
+	uint_t af_flag;
+	const char *af_name;
+} auxsecfl[] = {
+	{ PROC_SEC_ASLR,	"aslr" },
+};
+
+/*ARGSUSED*/
+static void
+at_secflags(long val, char *instr, size_t n, char *str)
+{
+	int i;
+
+	*str = '\0';
+
+	for (i = 0; i < sizeof (auxsecfl)/sizeof (struct auxsecfl); i++) {
+		if ((val & auxsecfl[i].af_flag) != 0) {
+			if (*str != '\0')
+				(void) strlcat(str, ",", n);
+			(void) strlcat(str, auxsecfl[i].af_name, n);
+		}
+	}
+}
+
 #define	MAX_AT_NAME_LEN	15
 
 struct aux_id {
@@ -812,7 +836,8 @@
 	{ AT_SUN_BRANDNAME,	"AT_SUN_BRANDNAME",	at_str	},
 	{ AT_SUN_BRAND_AUX1,	"AT_SUN_BRAND_AUX1",	at_null	},
 	{ AT_SUN_BRAND_AUX2,	"AT_SUN_BRAND_AUX2",	at_null	},
-	{ AT_SUN_BRAND_AUX3,	"AT_SUN_BRAND_AUX3",	at_null	}
+	{ AT_SUN_BRAND_AUX3,	"AT_SUN_BRAND_AUX3",	at_null	},
+	{ AT_SUN_SECFLAGS,	"AT_SUN_SECFLAGS",	at_secflags },
 };
 
 #define	N_AT_ENTS (sizeof (aux_arr) / sizeof (struct aux_id))
--- /dev/null	2015-05-27 22:21:46.000000000 -0400
+++ new/usr/src/cmd/ptools/psecflags/psecflags.c	2015-05-27 22:21:46.286534804 -0400
@@ -0,0 +1,351 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+#include <err.h>
+#include <errno.h>
+#include <grp.h>
+#include <libintl.h>
+#include <procfs.h>
+#include <project.h>
+#include <pwd.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include <libproc.h>
+#include <libzonecfg.h>
+
+extern const char *__progname;
+extern int psecflags(idtype_t, id_t, psecflags_cmd_t, uint_t);
+
+struct flagdesc {
+	uint_t value;
+	char *name;
+} flagdescs[] = {
+	{ PROC_SEC_ASLR, "aslr" },
+	{ 0x0, NULL }
+};
+
+void
+print_flags(char *set, uint_t flags)
+{
+	char *buf;
+	size_t buflen = 13;	/* 0x + 8 digits + comma + space + NUL */
+	struct flagdesc *fd;
+
+	if (flags == 0) {
+		(void) printf(gettext("\t%s:\tnone\n"), set);
+		return;
+	}
+
+	for (fd = flagdescs; fd->value != 0x0; fd++)
+		buflen += strlen(fd->name) + 2; /* + comma, space */
+
+	if ((buf = calloc(buflen, sizeof (char))) == NULL)
+		err(1, gettext("allocation failed"));
+
+	for (fd = flagdescs; fd->value != 0; fd++) {
+		if (flags & fd->value)
+			(void) snprintf(buf, buflen, "%s, %s", buf, fd->name);
+		flags &= ~fd->value;
+	}
+
+	if (flags != 0)	/* Contained unknown flags */
+		(void) snprintf(buf, buflen, "%s, 0x%08x", buf, flags);
+
+	buf += 2;		/* Skip the comma on the first entry */
+
+	(void) printf("\t%s:\t%s\n", set, buf);
+	free(buf);
+}
+
+typedef struct {
+	psecflags_cmd_t cmd;
+	uint_t value;
+} act_arg_t;
+
+act_arg_t *
+parse_secflags(const char *spec)
+{
+	char *flag = NULL;
+	char *s;
+	struct flagdesc *fd;
+	boolean_t fail = B_FALSE;
+	act_arg_t *ret;
+
+	if ((ret = malloc(sizeof (act_arg_t))) == NULL)
+		err(1, gettext("allocation failed"));
+
+	if ((s = strdup(spec)) == NULL)
+		err(1, gettext("allocation failed"));
+
+	if (s[0] == '+') {
+		ret->cmd = PSECFLAGS_ENABLE;
+		s++;
+	} else if (s[0] == '-') {
+		ret->cmd = PSECFLAGS_DISABLE;
+		s++;
+	} else {
+		ret->cmd = PSECFLAGS_SET;
+	}
+
+	if (strncasecmp("none", s, strlen(s)) == 0) {
+		if (ret->cmd != PSECFLAGS_SET)
+			errx(1, gettext("'none' is only valid with set, not "
+			    "enable or disable"));
+		ret->value = 0x0;
+		free(s);
+		return (ret);
+	}
+
+next:
+	while ((flag = strsep(&s, ",")) != NULL) {
+		for (fd = flagdescs; fd->value != 0x0; fd++) {
+			if (strncasecmp(flag, fd->name,
+			    strlen(fd->name)) == 0) {
+				ret->value |= fd->value;
+				goto next;
+			}
+		}
+
+		if (strncasecmp("none", flag, strlen(flag)) == 0) {
+			(void) fprintf(stderr, gettext("%s: 'none' is not "
+			    "valid with other flags\n"), __progname);
+		} else {
+			(void) fprintf(stderr, gettext("%s: invalid "
+			    "security-flag: '%s'\n"),
+			    __progname, flag);
+		}
+		fail = B_TRUE;
+	}
+
+	free(s);
+
+	if (fail)
+		exit(1);
+
+	return (ret);
+}
+
+/*
+ * Structure defining idtypes known to the priocntl command
+ * along with the corresponding names and a liberal guess
+ * of the max number of procs sharing any given ID of that type.
+ * The idtype values themselves are defined in <sys/procset.h>.
+ */
+static struct idtypes {
+	idtype_t	type;
+	char		*name;
+} idtypes [] = {
+	{ P_ALL,	"all"		},
+	{ P_CTID,	"contract"	},
+	{ P_CTID,	"ctid"		},
+	{ P_GID,	"gid"		},
+	{ P_GID,	"group"		},
+	{ P_PGID,	"pgid"		},
+	{ P_PID,	"pid"		},
+	{ P_PPID,	"ppid"		},
+	{ P_PROJID,	"project"	},
+	{ P_PROJID,	"projid"	},
+	{ P_SID,	"session",	},
+	{ P_SID,	"sid"		},
+	{ P_SID,	"sid"		},
+	{ P_TASKID,	"taskid"	},
+	{ P_UID,	"uid"		},
+	{ P_UID,	"user"		},
+	{ P_ZONEID,	"zone"		},
+	{ P_ZONEID,	"zoneid"	},
+	{ 0, 		NULL		}
+};
+
+int
+str2idtype(char *idtypnm, idtype_t *idtypep)
+{
+	struct idtypes	*curp;
+
+	for (curp = idtypes; curp->name != NULL; curp++) {
+		if (strncasecmp(curp->name, idtypnm,
+		    strlen(curp->name)) == 0) {
+			*idtypep = curp->type;
+			return (0);
+		}
+	}
+	return (-1);
+}
+
+id_t
+getid(idtype_t type, char *value)
+{
+	struct passwd *pwd;
+	struct group *grp;
+	id_t ret;
+	char *endp;
+
+	switch (type) {
+	case P_UID:
+		if ((pwd = getpwnam(value)) != NULL)
+			return (pwd->pw_uid);
+		break;
+	case P_GID:
+		if ((grp = getgrnam(value)) != NULL)
+			return (grp->gr_gid);
+		break;
+	case P_PROJID:
+		if ((ret = getprojidbyname(value)) != (id_t)-1)
+			return (ret);
+		break;
+	case P_ZONEID:
+		if (zone_get_id(value, &ret) == 0)
+			return (ret);
+		break;
+	default:
+		break;
+	}
+
+	ret = (id_t)strtoul(value, &endp, 10);
+	if (errno || *endp != '\0')
+		return ((id_t)-1);
+
+	return (ret);
+}
+
+int
+main(int argc, char **argv)
+{
+	act_arg_t *act = NULL;
+	int ret = 0;
+	int pgrab_flags = PGRAB_RDONLY;
+	int opt;
+	char *idtypename = NULL;
+	idtype_t idtype = P_PID;
+	boolean_t usage = B_FALSE;
+	boolean_t e_flag = B_FALSE;
+	boolean_t l_flag = B_FALSE;
+
+	while ((opt = getopt(argc, argv, "eFi:ls:")) != -1) {
+		switch (opt) {
+		case 'e':
+			e_flag = B_TRUE;
+			break;
+		case 'F':
+			pgrab_flags |= PGRAB_FORCE;
+			break;
+		case 'i':
+			idtypename = optarg;
+			break;
+		case 's':
+			act = parse_secflags(optarg);
+			break;
+		case 'l':
+			l_flag = B_TRUE;
+			break;
+		default:
+			usage = B_TRUE;
+			break;
+		}
+	}
+
+	argc -= optind;
+	argv += optind;
+
+	if (l_flag && ((idtypename != NULL) || (act != NULL) || (argc != 0)))
+		usage = B_TRUE;
+	if ((idtypename != NULL) && (act == NULL))
+		usage = B_TRUE;
+	if (e_flag && (act == NULL))
+		usage = B_TRUE;
+	if (!l_flag && argc <= 0)
+		usage = B_TRUE;
+
+	if (usage) {
+		(void) fprintf(stderr,
+		    gettext("usage:\t%s [-F] { pid | core } ...\n"),
+		    __progname);
+		(void) fprintf(stderr,
+		    gettext("\t%s -s [-+]flags [-i idtype] id ...\n"),
+		    __progname);
+		(void) fprintf(stderr,
+		    gettext("\t%s -s [-+]flags -e command [arg]...\n"),
+		    __progname);
+		(void) fprintf(stderr, gettext("\t%s -l\n"), __progname);
+		return (2);
+	}
+
+	if (l_flag) {
+		struct flagdesc *fd;
+
+		for (fd = flagdescs; fd->value != 0x0; fd++) {
+			(void) printf("%s\n", fd->name);
+		}
+		return (0);
+	} else if ((act != NULL) && e_flag) {
+		if (psecflags(P_PID, P_MYID, act->cmd, act->value) != 0)
+			err(1, gettext("failed setting security-flags"));
+
+		(void) execvp(argv[0], &argv[0]);
+		err(1, "%s", argv[0]);
+	} else if (act != NULL) {
+		int i;
+		id_t id;
+
+		if (idtypename != NULL)
+			if (str2idtype(idtypename, &idtype) == -1)
+				errx(1, gettext("No such id type: '%s'"),
+				    idtypename);
+
+		for (i = 0; i < argc; i++) {
+			if ((id = getid(idtype, argv[i])) == (id_t)-1) {
+				errx(1, gettext("invalid or non-existent "
+				    "identifier: '%s'"), argv[i]);
+			}
+
+			if (psecflags(idtype, id, act->cmd, act->value) != 0)
+				err(1, gettext("failed setting "
+				    "security-flags"));
+		}
+
+		return (0);
+	}
+
+	/* Display the flags for the given pids */
+	while (argc-- > 0) {
+		struct ps_prochandle *Pr;
+		const char *arg;
+		psinfo_t psinfo;
+		int gcode;
+
+		if ((Pr = proc_arg_grab(arg = *argv++, PR_ARG_ANY,
+		    pgrab_flags, &gcode)) == NULL) {
+			warnx(gettext("cannot examine %s: %s"),
+			    arg, Pgrab_error(gcode));
+			ret = 1;
+			continue;
+		}
+
+		(void) memcpy(&psinfo, Ppsinfo(Pr), sizeof (psinfo_t));
+		proc_unctrl_psinfo(&psinfo);
+
+		if (Pstate(Pr) == PS_DEAD) {
+			(void) printf(gettext("core '%s' of %d:\t%.70s\n"),
+			    arg, (int)psinfo.pr_pid, psinfo.pr_psargs);
+		} else {
+			(void) printf("%d:\t%.70s\n",
+			    (int)psinfo.pr_pid, psinfo.pr_psargs);
+		}
+
+		print_flags("E", Pstatus(Pr)->pr_secflags.psf_effective);
+		print_flags("I", Pstatus(Pr)->pr_secflags.psf_inherit);
+
+		Prelease(Pr, 0);
+	}
+
+	return (ret);
+}
--- old/usr/src/cmd/sgs/dump/common/dump.c	2015-05-27 22:21:47.723375760 -0400
+++ new/usr/src/cmd/sgs/dump/common/dump.c	2015-05-27 22:21:47.764760718 -0400
@@ -1225,6 +1225,7 @@
 			case DT_SUNW_STRPAD:
 			case DT_SUNW_CAPCHAINENT:
 			case DT_SUNW_CAPCHAINSZ:
+			case DT_SUNW_ASLR:
 				(void) printf(pdyn_Fmtptr,
 				    EC_XWORD(p_dyn.d_un.d_val));
 				break;
--- old/usr/src/cmd/sgs/elfdump/common/corenote.c	2015-05-27 22:21:48.323406745 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/corenote.c	2015-05-27 22:21:48.360506336 -0400
@@ -436,6 +436,7 @@
 		Conv_cap_val_hw2_buf_t		hw2;
 		Conv_cnote_auxv_af_buf_t	auxv_af;
 		Conv_ehdr_flags_buf_t		ehdr_flags;
+		Conv_secflags_buf_t		secflags;
 		Conv_inv_buf_t			inv;
 	} conv_buf;
 	sl_fmtbuf_t	buf;
@@ -487,6 +488,11 @@
 			num_fmt = SL_FMT_NUM_HEX;
 			break;
 
+		case AT_SUN_SECFLAGS:
+			w = extract_as_word(state, &layout->a_val);
+			vstr = conv_psecflags(w, 0, &conv_buf.secflags);
+			break;
+
 		case AT_EXECFD:
 		case AT_PHENT:
 		case AT_PHNUM:
@@ -827,6 +833,26 @@
 	indent_exit(state);
 }
 
+/*
+ * Output information from psecflags_t structure.
+ */
+static void
+dump_secflags(note_state_t *state, const char *title)
+{
+	const sl_psecflags_layout_t *layout = state->ns_arch->psecflags;
+	Conv_secflags_buf_t inv;
+	Word w;
+
+	indent_enter(state, title, &layout->psf_effective);
+
+	w = extract_as_word(state, &layout->psf_effective);
+	print_str(state, MSG_ORIG(MSG_CNOTE_T_PSF_EFFECTIVE),
+	    conv_psecflags(w, 0, &inv));
+
+	w = extract_as_word(state, &layout->psf_inherit);
+	print_str(state, MSG_ORIG(MSG_CNOTE_T_PSF_INHERIT),
+	    conv_psecflags(w, 0, &inv));
+}
 
 /*
  * Output information from utsname structure.
@@ -1097,6 +1123,10 @@
 	state->ns_vcol += 5;
 	state->ns_t2col += 5;
 	state->ns_v2col += 5;
+
+	PRINT_SUBTYPE(MSG_ORIG(MSG_CNOTE_T_PR_SECFLAGS), pr_secflags,
+	    dump_secflags);
+
 	PRINT_SUBTYPE(MSG_ORIG(MSG_CNOTE_T_PR_LWP), pr_lwp, dump_lwpstatus);
 	state->ns_vcol -= 5;
 	state->ns_t2col -= 5;
--- old/usr/src/cmd/sgs/elfdump/common/elfdump.msg	2015-05-27 22:21:48.898583725 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/elfdump.msg	2015-05-27 22:21:48.918347222 -0400
@@ -561,6 +561,7 @@
 @ MSG_CNOTE_T_PR_RUID			"pr_ruid:"
 @ MSG_CNOTE_T_PR_RVAL1			"pr_rval1:"
 @ MSG_CNOTE_T_PR_RVAL2			"pr_rval2:"
+@ MSG_CNOTE_T_PR_SECFLAGS		"pr_secflags:"
 @ MSG_CNOTE_T_PR_SETS			"pr_sets:"
 @ MSG_CNOTE_T_PR_SETSIZE		"pr_setsize:"
 @ MSG_CNOTE_T_PR_SGID			"pr_sgid:"
@@ -595,6 +596,8 @@
 @ MSG_CNOTE_T_PR_WSTAT			"pr_wstat:"
 @ MSG_CNOTE_T_PR_ZOMB			"pr_zomb:"
 @ MSG_CNOTE_T_PR_ZONEID			"pr_zoneid:"
+@ MSG_CNOTE_T_PSF_EFFECTIVE		"psf_effective:"
+@ MSG_CNOTE_T_PSF_INHERIT		"psf_inherit:"
 @ MSG_CNOTE_T_SA_FLAGS			"sa_flags:"
 @ MSG_CNOTE_T_SA_HANDLER		"sa_handler:"
 @ MSG_CNOTE_T_SA_MASK			"sa_mask:"
@@ -658,3 +661,4 @@
 @ MSG_PHDRNAM_TLSSORT		".SUNW_tlssort(phdr)"
 @ MSG_PHDRNAM_UNWIND		".eh_frame_hdr(phdr)"
 @ MSG_PHDRNAM_VER		".SUNW_version(phdr)"
+
--- old/usr/src/cmd/sgs/elfdump/common/gen_struct_layout.c	2015-05-27 22:21:49.672826508 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/gen_struct_layout.c	2015-05-27 22:21:49.847350428 -0400
@@ -198,6 +198,7 @@
 	SCALAR_FIELD(pstatus_t,		pr_projid,	1);
 	SCALAR_FIELD(pstatus_t,		pr_nzomb,	1);
 	SCALAR_FIELD(pstatus_t,		pr_zoneid,	1);
+	SCALAR_FIELD(pstatus_t,		pr_secflags,	0);
 	SCALAR_FIELD(pstatus_t,		pr_lwp,		0);
 
 	END;
@@ -587,6 +588,15 @@
 	END;
 }
 
+static void
+gen_psecflags(void)
+{
+	START(psecflags, psecflags_t);
+	SCALAR_FIELD(psecflags_t, psf_effective, 0);
+	SCALAR_FIELD(psecflags_t, psf_inherit, 0);
+	END;
+}
+
 
 /*ARGSUSED*/
 int
@@ -628,6 +638,7 @@
 	gen_timestruc();
 	gen_utsname();
 	gen_prfdinfo();
+	gen_psecflags();
 
 
 	/*
@@ -656,6 +667,7 @@
 	(void) printf(fmt, "timestruc");
 	(void) printf(fmt, "utsname");
 	(void) printf(fmt, "prfdinfo");
+	(void) printf(fmt, "psecflags");
 	(void) printf("};\n");
 
 	/*
--- old/usr/src/cmd/sgs/elfdump/common/struct_layout.h	2015-05-27 22:21:50.691762191 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/struct_layout.h	2015-05-27 22:21:50.753240465 -0400
@@ -208,6 +208,7 @@
 	sl_field_t		pr_projid;
 	sl_field_t		pr_nzomb;
 	sl_field_t		pr_zoneid;
+	sl_field_t		pr_secflags;
 	sl_field_t		pr_lwp;
 } sl_pstatus_layout_t;
 
@@ -526,6 +527,12 @@
 	sl_field_t		pr_path;
 } sl_prfdinfo_layout_t;
 
+typedef struct {
+	sl_field_t		sizeof_struct;
+	sl_field_t		psf_effective;
+	sl_field_t		psf_inherit;
+} sl_psecflags_layout_t;
+
 /*
  * This type collects all of the layout definitions for
  * a given architecture.
@@ -551,6 +558,7 @@
 	const sl_timestruc_layout_t	*timestruc;	/* timestruc_t */
 	const sl_utsname_layout_t	*utsname;	/* struct utsname */
 	const sl_prfdinfo_layout_t	*prfdinfo;	/* prdinfo_t */
+	const sl_psecflags_layout_t	*psecflags;	/* psecflags_t */
 } sl_arch_layout_t;
 
 
--- old/usr/src/cmd/sgs/elfdump/common/struct_layout_amd64.c	2015-05-27 22:21:51.173722155 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/struct_layout_amd64.c	2015-05-27 22:21:51.192145800 -0400
@@ -104,6 +104,7 @@
 	{ 312,	4,	0,	1 },		/* pr_projid */
 	{ 316,	4,	0,	1 },		/* pr_nzomb */
 	{ 320,	4,	0,	1 },		/* pr_zoneid */
+	{ 324,	8,	0,	0 },		/* pr_secflags */
 	{ 384,	1296,	0,	0 },		/* pr_lwp */
 };
 
@@ -377,6 +378,13 @@
 };
 
 
+static const sl_psecflags_layout_t psecflags_layout = {
+	{ 0,	8,	0,	0 },		/* sizeof (psecflags_t) */
+	{ 0,	4,	0,	0 },		/* psf_effective */
+	{ 4,	4,	0,	0 },		/* psf_inherit */
+};
+
+
 
 
 static const sl_arch_layout_t layout_amd64 = {
@@ -400,6 +408,7 @@
 	&timestruc_layout,
 	&utsname_layout,
 	&prfdinfo_layout,
+	&psecflags_layout,
 };
 
 
--- old/usr/src/cmd/sgs/elfdump/common/struct_layout_i386.c	2015-05-27 22:21:51.657890524 -0400
+++ new/usr/src/cmd/sgs/elfdump/common/struct_layout_i386.c	2015-05-27 22:21:51.670330463 -0400
@@ -104,6 +104,7 @@
 	{ 264,	4,	0,	1 },		/* pr_projid */
 	{ 268,	4,	0,	1 },		/* pr_nzomb */
 	{ 272,	4,	0,	1 },		/* pr_zoneid */
+	{ 276,	8,	0,	0 },		/* pr_secflags */
 	{ 336,	800,	0,	0 },		/* pr_lwp */
 };
 
@@ -377,6 +378,13 @@
 };
 
 
+static const sl_psecflags_layout_t psecflags_layout = {
+	{ 0,	8,	0,	0 },		/* sizeof (psecflags_t) */
+	{ 0,	4,	0,	0 },		/* psf_effective */
+	{ 4,	4,	0,	0 },		/* psf_inherit */
+};
+
+
 
 
 static const sl_arch_layout_t layout_i386 = {
@@ -400,6 +408,7 @@
 	&timestruc_layout,
 	&utsname_layout,
 	&prfdinfo_layout,
+	&psecflags_layout,
 };
 
 
--- old/usr/src/cmd/sgs/include/conv.h	2015-05-27 22:21:52.115486920 -0400
+++ new/usr/src/cmd/sgs/include/conv.h	2015-05-27 22:21:52.140928076 -0400
@@ -325,6 +325,12 @@
 	char				buf[CONV_CNOTE_PROC_FLAG_BUFSIZE];
 } Conv_cnote_proc_flag_buf_t;
 
+/* conv_psecflags() */
+#define	CONV_PSECFLAGS_BUFSIZE		31
+typedef union {
+	Conv_inv_buf_t			inv_buf;
+	char				buf[CONV_PSECFLAGS_BUFSIZE];
+} Conv_secflags_buf_t;
 
 /* conv_cnote_sigset() */
 #define	CONV_CNOTE_SIGSET_BUFSIZE	639
@@ -822,6 +828,8 @@
 			    Conv_inv_buf_t *);
 extern	const char	*conv_cnote_priv(int, Conv_fmt_flags_t,
 			    Conv_inv_buf_t *);
+extern	const char	*conv_psecflags(int, Conv_fmt_flags_t,
+			    Conv_secflags_buf_t *);
 extern	const char	*conv_cnote_psetid(int, Conv_fmt_flags_t,
 			    Conv_inv_buf_t *);
 extern	const char	*conv_cnote_sa_flags(int, Conv_fmt_flags_t,
--- old/usr/src/cmd/sgs/include/libld.h	2015-05-27 22:21:52.614220325 -0400
+++ new/usr/src/cmd/sgs/include/libld.h	2015-05-27 22:21:52.662817038 -0400
@@ -406,6 +406,11 @@
 	avl_tree_t	*ofl_wrap;	/* -z wrap symbols */
 	ofl_guideflag_t	ofl_guideflags;	/* -z guide flags */
 	APlist		*ofl_assdeflib;	/* -z assert-deflib exceptions */
+	int		ofl_aslr;	/* -z aslr, -1 is disable, 1 is enable */
+	/*
+	 * XXX: I'd rather this be ofl_secflags, -z secflags, and
+	 * DT_ILL_SECFLAGS, with ASLR and -z aslr for compat.  I think? maybe?
+	 */
 };
 
 #define	FLG_OF_DYNAMIC	0x00000001	/* generate dynamic output module */
--- old/usr/src/cmd/sgs/libconv/common/corenote.c	2015-05-27 22:21:53.203137020 -0400
+++ new/usr/src/cmd/sgs/libconv/common/corenote.c	2015-05-27 22:21:53.234641474 -0400
@@ -104,19 +104,20 @@
 	static const conv_ds_msg_t ds_types_2000_2011 = {
 	    CONV_DS_MSG_INIT(2000, types_2000_2011) };
 
-	static const Msg	types_2014_2023[] = {
+	static const Msg	types_2014_2024[] = {
 		MSG_AUXV_AT_SUN_EXECNAME,	MSG_AUXV_AT_SUN_MMU,
 		MSG_AUXV_AT_SUN_LDDATA,		MSG_AUXV_AT_SUN_AUXFLAGS,
 		MSG_AUXV_AT_SUN_EMULATOR,	MSG_AUXV_AT_SUN_BRANDNAME,
 		MSG_AUXV_AT_SUN_BRAND_AUX1,	MSG_AUXV_AT_SUN_BRAND_AUX2,
-		MSG_AUXV_AT_SUN_BRAND_AUX3,	MSG_AUXV_AT_SUN_HWCAP2
+		MSG_AUXV_AT_SUN_BRAND_AUX3,	MSG_AUXV_AT_SUN_HWCAP2,
+		MSG_AUXV_AT_SUN_SECFLAGS
 	};
-	static const conv_ds_msg_t ds_types_2014_2023 = {
-	    CONV_DS_MSG_INIT(2014, types_2014_2023) };
+	static const conv_ds_msg_t ds_types_2014_2024 = {
+	    CONV_DS_MSG_INIT(2014, types_2014_2024) };
 
 	static const conv_ds_t	*ds[] = {
 		CONV_DS_ADDR(ds_types_0_22), CONV_DS_ADDR(ds_types_2000_2011),
-		CONV_DS_ADDR(ds_types_2014_2023), NULL };
+		CONV_DS_ADDR(ds_types_2014_2024), NULL };
 
 	return (conv_map_ds(ELFOSABI_NONE, EM_NONE, type, ds, fmt_flags,
 	    inv_buf));
@@ -2582,3 +2583,45 @@
 	(void) conv_expn_field(&arg, vda, fmt_flags);
 	return (buf);
 }
+
+
+#define	PROCSECFLGSZ	CONV_EXPN_FIELD_DEF_PREFIX_SIZE + \
+	MSG_PROC_SEC_ASLR_SIZE		+ CONV_EXPN_FIELD_DEF_SEP_SIZE + \
+	CONV_INV_BUFSIZE		+ CONV_EXPN_FIELD_DEF_SUFFIX_SIZE
+
+/*
+ * Ensure that Conv_cnote_pr_secflags_buf_t is large enough:
+ *
+ * PROCSECFLGSZ is the real minimum size of the buffer required by
+ * conv_cnote_psecflags(). However, Conv_cnote_pr_secflags_buf_t uses
+ * CONV_CNOTE_PSECFLAGS_FLAG_BUFSIZE to set the buffer size. We do things this
+ * way because the definition of PROCSECFLGSZ uses information that is not
+ * available in the environment of other programs that include the conv.h
+ * header file.
+ */
+#if (CONV_PSECFLAGS_BUFSIZE != PROCSECFLGSZ) && !defined(__lint)
+#define	REPORT_BUFSIZE PROCSECFLGSZ
+#include "report_bufsize.h"
+#error "CONV_PSECFLAGS_BUFSIZE does not match PROCSECFLGSZ"
+#endif
+
+const char *
+conv_psecflags(int flags, Conv_fmt_flags_t fmt_flags,
+    Conv_secflags_buf_t *secflags_buf)
+{
+	static const Val_desc vda[] = {
+		{ 0x0001,		MSG_PROC_SEC_ASLR },
+		{ 0,			0 }
+	};
+	static CONV_EXPN_FIELD_ARG conv_arg = {
+	    NULL, sizeof (secflags_buf->buf) };
+
+	if (flags == 0)
+		return (MSG_ORIG(MSG_GBL_ZERO));
+
+	conv_arg.buf = secflags_buf->buf;
+	conv_arg.oflags = conv_arg.rflags = flags;
+	(void) conv_expn_field(&conv_arg, vda, fmt_flags);
+
+	return ((const char *)secflags_buf->buf);
+}
--- old/usr/src/cmd/sgs/libconv/common/corenote.msg	2015-05-27 22:21:53.948531704 -0400
+++ new/usr/src/cmd/sgs/libconv/common/corenote.msg	2015-05-27 22:21:53.975103380 -0400
@@ -100,6 +100,7 @@
 @ MSG_AUXV_AT_SUN_BRAND_AUX2		"SUN_BRAND_AUX2"
 @ MSG_AUXV_AT_SUN_BRAND_AUX3		"SUN_BRAND_AUX3"
 @ MSG_AUXV_AT_SUN_HWCAP2		"SUN_HWCAP2"
+@ MSG_AUXV_AT_SUN_SECFLAGS		"SUN_SECFLAGS"
 
 
 @ MSG_CC_CONTENT_STACK		"STACK"
@@ -277,6 +278,8 @@
 @ MSG_PROC_FLAG_SSYS		"SSYS"
 @ MSG_PROC_FLAG_SMSACCT		"SMSACCT"
 
+@ MSG_PROC_SEC_ASLR		"ASLR"
+
 @ MSG_PS_NONE			"[ PS_NONE ]"
 @ MSG_PS_QUERY			"[ PS_QUERY ]"
 @ MSG_PS_MYID			"[ PS_MYID ]"
--- old/usr/src/cmd/sgs/libconv/common/dynamic.c	2015-05-27 22:21:55.058477350 -0400
+++ new/usr/src/cmd/sgs/libconv/common/dynamic.c	2015-05-27 22:21:55.772765401 -0400
@@ -556,7 +556,9 @@
 		MSG_DT_SUNW_STRPAD_CF,		MSG_DT_SUNW_CAPCHAIN_CF,
 		MSG_DT_SUNW_LDMACH_CF,		0,
 		MSG_DT_SUNW_CAPCHAINENT_CF,	0,
-		MSG_DT_SUNW_CAPCHAINSZ_CF
+		MSG_DT_SUNW_CAPCHAINSZ_CF,	0,
+		0, 				0,
+		MSG_DT_SUNW_ASLR_CF
 	};
 	static const Msg	tags_sunw_auxiliary_cfnp[] = {
 		MSG_DT_SUNW_AUXILIARY_CFNP,	MSG_DT_SUNW_RTLDINF_CFNP,
@@ -568,7 +570,9 @@
 		MSG_DT_SUNW_STRPAD_CFNP,	MSG_DT_SUNW_CAPCHAIN_CFNP,
 		MSG_DT_SUNW_LDMACH_CFNP,	0,
 		MSG_DT_SUNW_CAPCHAINENT_CFNP,	0,
-		MSG_DT_SUNW_CAPCHAINSZ_CFNP
+		MSG_DT_SUNW_CAPCHAINSZ_CFNP,	0,
+		0,				0,
+		MSG_DT_SUNW_ASLR_CFNP
 	};
 	static const Msg	tags_sunw_auxiliary_nf[] = {
 		MSG_DT_SUNW_AUXILIARY_NF,	MSG_DT_SUNW_RTLDINF_NF,
@@ -580,7 +584,9 @@
 		MSG_DT_SUNW_STRPAD_NF,		MSG_DT_SUNW_CAPCHAIN_NF,
 		MSG_DT_SUNW_LDMACH_NF,		0,
 		MSG_DT_SUNW_CAPCHAINENT_NF,	0,
-		MSG_DT_SUNW_CAPCHAINSZ_NF
+		MSG_DT_SUNW_CAPCHAINSZ_NF,	0,
+		0,				0,
+		MSG_DT_SUNW_ASLR_NF
 	};
 	static const conv_ds_msg_t ds_sunw_auxiliary_cf = {
 	    CONV_DS_MSG_INIT(DT_SUNW_AUXILIARY, tags_sunw_auxiliary_cf) };
--- old/usr/src/cmd/sgs/libconv/common/dynamic.msg	2015-05-27 22:21:56.266397990 -0400
+++ new/usr/src/cmd/sgs/libconv/common/dynamic.msg	2015-05-27 22:21:56.278450412 -0400
@@ -178,6 +178,9 @@
 @ MSG_DT_SUNW_CAPCHAINSZ_CF	"DT_SUNW_CAPCHAINSZ"		# 0x6000001d
 @ MSG_DT_SUNW_CAPCHAINSZ_CFNP		"SUNW_CAPCHAINSZ"
 @ MSG_DT_SUNW_CAPCHAINSZ_NF		"sunw_capchainsz"
+@ MSG_DT_SUNW_ASLR_CF		"DT_SUNW_ASLR"			# 0x60000023
+@ MSG_DT_SUNW_ASLR_CFNP			"SUNW_ASLR"
+@ MSG_DT_SUNW_ASLR_NF			"sunw_aslr"
 
 @ MSG_DT_GNU_PRELINKED_CF	"DT_GNU_PRELINKED"		# 0x6ffffdf5
 @ MSG_DT_GNU_PRELINKED_CFNP		"GNU_PRELINKED"
--- old/usr/src/cmd/sgs/libld/common/args.c	2015-05-27 22:21:56.723358779 -0400
+++ new/usr/src/cmd/sgs/libld/common/args.c	2015-05-27 22:21:56.755966047 -0400
@@ -940,7 +940,6 @@
 	    MSG_STR_SOEXT_SIZE;
 	if (olen > MSG_ARG_ASSDEFLIB_SIZE) {
 		if (optarg[MSG_ARG_ASSDEFLIB_SIZE] != '=') {
-			ld_eprintf(ofl, ERR_FATAL, "Missing =\n");
 			ld_eprintf(ofl, ERR_FATAL, MSG_INTL(MSG_ARG_ILLEGAL),
 			    MSG_ORIG(MSG_ARG_ASSDEFLIB), optarg);
 			return (TRUE);
@@ -1437,6 +1436,32 @@
 				if (ld_wrap_enter(ofl,
 				    optarg + MSG_ARG_WRAP_SIZE) == NULL)
 					return (S_ERROR);
+			} else if (strncmp(optarg, MSG_ORIG(MSG_ARG_ASLR),
+			    MSG_ARG_ASLR_SIZE) == 0) {
+				char *p = optarg + MSG_ARG_ASLR_SIZE;
+				if (*p == '\0') {
+					ofl->ofl_aslr = 1;
+				} else if (*p == '=') {
+					p++;
+
+					if (strcmp(p,
+					    MSG_ORIG(MSG_ARG_ENABLED)) == 0) {
+						ofl->ofl_aslr = 1;
+					} else if (strcmp(p,
+					    MSG_ORIG(MSG_ARG_DISABLED)) == 0) {
+						ofl->ofl_aslr = -1;
+					} else {
+						ld_eprintf(ofl, ERR_FATAL,
+						    MSG_INTL(MSG_ARG_ILLEGAL),
+						    MSG_ORIG(MSG_ARG_ZASLR), p);
+						return (S_ERROR);
+					}
+				} else {
+					ld_eprintf(ofl, ERR_FATAL,
+					    MSG_INTL(MSG_ARG_ILLEGAL),
+					    MSG_ORIG(MSG_ARG_Z), optarg);
+					return (S_ERROR);
+				}
 			} else if ((strncmp(optarg, MSG_ORIG(MSG_ARG_GUIDE),
 			    MSG_ARG_GUIDE_SIZE) == 0) &&
 			    ((optarg[MSG_ARG_GUIDE_SIZE] == '=') ||
--- old/usr/src/cmd/sgs/libld/common/libld.msg	2015-05-27 22:21:57.340770283 -0400
+++ new/usr/src/cmd/sgs/libld/common/libld.msg	2015-05-27 22:21:57.362207979 -0400
@@ -1358,6 +1358,7 @@
 @ MSG_ARG_CYU		"-YU"
 @ MSG_ARG_Z		"-z"
 @ MSG_ARG_ZDEFNODEF	"-z[defs|nodefs]"
+@ MSG_ARG_ZASLR		"-zaslr"
 @ MSG_ARG_ZGUIDE	"-zguidance"
 @ MSG_ARG_ZNODEF	"-znodefs"
 @ MSG_ARG_ZNOINTERP	"-znointerp"
@@ -1374,6 +1375,7 @@
 
 @ MSG_ARG_ABSEXEC	"absexec"
 @ MSG_ARG_ALTEXEC64	"altexec64"
+@ MSG_ARG_ASLR		"aslr"
 @ MSG_ARG_NOCOMPSTRTAB	"nocompstrtab"
 @ MSG_ARG_GROUPPERM	"groupperm"
 @ MSG_ARG_NOGROUPPERM	"nogroupperm"
@@ -1474,6 +1476,9 @@
 @ MSG_ARG_T_OPAR	"("
 @ MSG_ARG_T_CPAR	")"
 
+@ MSG_ARG_ENABLED	"enabled"
+@ MSG_ARG_DISABLED	"disabled"
+
 # -z guidance=item strings
 @ MSG_ARG_GUIDE_DELIM		",: \t"
 @ MSG_ARG_GUIDE_NO_ALL		"noall"
--- old/usr/src/cmd/sgs/libld/common/sections.c	2015-05-27 22:21:57.863187724 -0400
+++ new/usr/src/cmd/sgs/libld/common/sections.c	2015-05-27 22:21:57.877069156 -0400
@@ -1269,6 +1269,9 @@
 
 		if (flags & FLG_OF_SYMBOLIC)
 			cnt++;			/* DT_SYMBOLIC */
+
+		if (ofl->ofl_aslr != 0)		/* DT_SUNW_ASLR */
+			cnt++;
 	}
 
 	/*
--- old/usr/src/cmd/sgs/libld/common/update.c	2015-05-27 22:21:58.566668037 -0400
+++ new/usr/src/cmd/sgs/libld/common/update.c	2015-05-27 22:21:58.581091609 -0400
@@ -2532,6 +2532,13 @@
 			dyn->d_un.d_val = shdr->sh_entsize;
 			dyn++;
 		}
+
+		if (ofl->ofl_aslr != 0) {
+			dyn->d_tag = DT_SUNW_ASLR;
+			dyn->d_un.d_val = (ofl->ofl_aslr == 1);
+			dyn++;
+		}
+
 		if (flags & FLG_OF_SYMBOLIC) {
 			dyn->d_tag = DT_SYMBOLIC;
 			dyn->d_un.d_val = 0;
--- old/usr/src/cmd/svc/milestone/Makefile	2015-05-27 22:21:59.303076820 -0400
+++ new/usr/src/cmd/svc/milestone/Makefile	2015-05-27 22:21:59.398757493 -0400
@@ -75,6 +75,7 @@
 	early-manifest-import.xml \
 	identity.xml \
 	manifest-import.xml \
+	process-security.xml \
 	rmtmpfiles.xml	\
 	vtdaemon.xml
 
--- old/usr/src/cmd/svc/startd/startd.c	2015-05-27 22:22:00.430363050 -0400
+++ new/usr/src/cmd/svc/startd/startd.c	2015-05-27 22:22:00.442887714 -0400
@@ -203,6 +203,7 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <sys/wait.h>
+#include <sys/proc.h>
 #include <assert.h>
 #include <errno.h>
 #include <fcntl.h>
@@ -224,6 +225,8 @@
 #include "startd.h"
 #include "protocol.h"
 
+extern int psecflags(idtype_t, id_t, psecflags_cmd_t, uint_t);
+
 ssize_t max_scf_name_size;
 ssize_t max_scf_fmri_size;
 ssize_t max_scf_value_size;
@@ -472,6 +475,69 @@
 
 extern int info_events_all;
 
+struct psf_desc {
+	char *name;
+	uint_t flag;
+} procsec_flag_tbl[] = {
+	{ "aslr",	PROC_SEC_ASLR },
+	{ NULL, NULL }
+};
+
+static void
+init_secflags(scf_handle_t *hndl)
+{
+	scf_property_t *prop;
+	scf_value_t *val;
+	struct psf_desc *psfd = NULL;
+	char *proc_sec_fmri = "svc:/system/process-security/"
+	    ":properties/secflags";
+
+	for (psfd = procsec_flag_tbl; psfd->name != NULL; psfd++) {
+		char *pfmri;
+		uint8_t flag;
+
+		prop = safe_scf_property_create(hndl);
+		val = safe_scf_value_create(hndl);
+
+		if ((pfmri = uu_msprintf("%s/%s", proc_sec_fmri, psfd->name)) == NULL)
+			uu_die("Allocation failure\n");
+
+		if (scf_handle_decode_fmri(hndl, pfmri,
+		    NULL, NULL, NULL, NULL, prop, NULL) != 0)
+			goto next;
+
+		if (scf_property_get_value(prop, val) != 0)
+			goto next;
+
+		(void) scf_value_get_boolean(val, &flag);
+
+		/*
+		 * XXX: This will fail if the zone had PRIV_PROC_SECFLAGS
+		 * removed.
+		 *
+		 * I'm not sure what we should do in that case -- I'd still
+		 * like this to be settable based on a zonecfg setting, too.
+		 *
+		 * We only set things explicitly _on_ here, rather than
+		 * explicitly _off_ such that a zone's settings do not
+		 * permanently override those from the GZ.
+		 *
+		 * XXX: This might be a bit crap, we sorta want a tri-state
+		 */
+		if (flag != 0) {
+			if (psecflags(P_PID, P_MYID,
+			    PSECFLAGS_ENABLE, psfd->flag) != 0) {
+				uu_warn("couldn't set security flags: %s\n",
+				    strerror(errno));
+			}
+		}
+next:
+		uu_free(pfmri);
+		scf_value_destroy(val);
+		scf_property_destroy(prop);
+	}
+}
+
 static int
 read_startd_config(void)
 {
@@ -601,6 +667,13 @@
 	    scf_property_get_value(prop, val) == 0)
 		(void) scf_value_get_boolean(val, &prop_reconfig);
 
+	/*
+	 * Set up the initial process secflags.  We do this super early, and
+	 * in svc.startd, so that it's inherited by as much stuff as possible
+	 * upon boot.
+	 */
+	init_secflags(hndl);
+
 	if (scf_handle_decode_fmri(hndl, startd_options_fmri, NULL, NULL, NULL,
 	    pg, NULL, SCF_DECODE_FMRI_TRUNCATE) == -1) {
 		/*
--- old/usr/src/cmd/truss/print.c	2015-05-27 22:22:00.978095990 -0400
+++ new/usr/src/cmd/truss/print.c	2015-05-27 22:22:01.009268236 -0400
@@ -67,6 +67,7 @@
 #include <sys/rtpriocntl.h>
 #include <sys/fsspriocntl.h>
 #include <sys/fxpriocntl.h>
+#include <sys/proc.h>
 #include <netdb.h>
 #include <nss_dbdefs.h>
 #include <sys/socketvar.h>
@@ -1600,6 +1601,56 @@
 }
 
 /*
+ * Print a psecflags(2) command
+ */
+void
+prt_psfcmd(private_t *pri, int raw, long val)
+{
+	const char *s = NULL;
+
+	if (raw == 0) {
+		switch ((psecflags_cmd_t)val) {
+		case PSECFLAGS_SET:
+			s = "PSECFLAGS_SET";
+			break;
+		case PSECFLAGS_DISABLE:
+			s = "PSECFLAGS_DISABLE";
+			break;
+		case PSECFLAGS_ENABLE:
+			s = "PSECFLAGS_ENABLE";
+			break;
+		}
+	}
+
+	if (s == NULL)
+		prt_dec(pri, 0, val);
+	else
+		outstring(pri, s);
+}
+
+void
+prt_psflags(private_t *pri, int raw, long val)
+{
+	char *str = pri->code_buf;
+
+	if (raw == 1) {
+		prt_hex(pri, 0, val);
+		return;
+	}
+
+	*str = '\0';
+	if (val & PROC_SEC_ASLR) {
+		(void) strlcat(str, "|PROC_SEC_ASLR", sizeof (pri->code_buf));
+		val &= ~PROC_SEC_ASLR;
+	}
+
+	if (val != 0)
+		(void) snprintf(str, sizeof (pri->code_buf), "%s|%x", str, val);
+
+	outstring(pri, str + 1);
+}
+
+/*
  * Print processor set id, including logical expansion of "special" ids.
  */
 void
@@ -2870,5 +2921,7 @@
 	prt_acf,	/* ACF -- print accept4 flags */
 	prt_pfd,	/* PFD -- print pipe fds */
 	prt_grf,	/* GRF -- print getrandom flags */
+	prt_psfcmd,	/* PSFCMD -- print psecflags(2) command */
+	prt_psflags,	/* PSFLG -- print psecflags(2) flags */
 	prt_dec,	/* HID -- hidden argument, make this the last one */
 };
